/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
static char ident[] = "@(#) $RCSfile: get_4byte.c,v $ $Revision: 2.0 $";

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include <netinet/in.h>
/*
 * get_4byte() - read and return a 4 byte integer from the network
 *
 *	Returns: the (unsigned int) integer in *val
 *		 the function return is 
 *			 0 for EOF,
 *			+1 for sucess, or
 *			-1 if error.
 */

int get_4byte(sock, val)
	int		 sock;	/* socket to read from */
	unsigned int	*val;	/* Return: interger from socket */
{
	
	int amt;
	union {
		int unl;
		char unc[sizeof (unsigned int)];
	} un;

	un.unl = 0;
	amt = read(sock, (char *)(un.unc+sizeof(unsigned int)-4), 4);
	if (amt == 4) {
		*val = ntohl(un.unl);
		return (1);
	} else if (amt == 0)
		return (0);
	else
		return (-1);
}
